﻿#include "RTU_Salve.h"
#include <bitset>
char read_buf[MAX_NUMBER];

bitset<MAX_Address> Coil_date; //0-9999
UINT16 Register[MAX_Address]; // 0-9999

/*********************************************************************************************
* 功能     ：   生成正常响应报文
* 描述	   ：	经过校验后请求报文可以正常响应
* 输入     ：   *Requst_Message 请求报文  *Normal_Response_Message 正常响应报文
* 返回值   ：   无
**********************************************************************************************/
void Create_Normal_Response_Message(UINT8 *Requst_Message, UINT8 *Normal_Response_Message)
{


}

/*********************************************************************************************
* 功能     ：   生成异常响应报文
* 描述	   ：	经过校验后请求报文可以正常响应
* 输入     ：   *Requst_Message 请求报文  *Normal_Response_Message 异常响应报文
* 返回值   ：   无
**********************************************************************************************/
void Create_Abnormal_Response_Message(UINT8 *Requst_Message, UINT8 *Abnormal_Response_Message)
{


}


void Create_0x01_Response_Message(UINT8 *Requst_Message, UINT8 *Response_Message, unsigned int Address_range)
{
	if (Address_range > MAX_Address)
	{
		int Read_Number = Requst_Message[4] << 8 | Requst_Message[5];

	}
	else
	{

	}
}
void Create_0x03_Response_Message(UINT8 *Requst_Message, UINT8 *Response_Message, unsigned int Address_range)
{

}
void Create_0x0F_Response_Message(UINT8 *Requst_Message, UINT8 *Response_Message, unsigned int Address_range)
{

}
void Create_0x10_Response_Message(UINT8 *Requst_Message, UINT8 *Response_Message, unsigned int Address_range)
{

}


/*********************************************************************************************
* 功能     ：   生成响应报文
* 描述	   ：	检查设备请求报文来生成对应功能的响应报文
* 输入     ：   *Requst_Message 请求报文 *Response_Message响应报文
* 返回值   ：   true  生成响应报文
*				false 不生成响应报文
**********************************************************************************************/
bool Create_Response_Message(UINT8 *Requst_Message, UINT8 *Response_Message)
{
	if (Requst_Message[0] != Device_ID) //检查设备ID一致
		return false;
	unsigned int Address_range = (Requst_Message[2] << 8 | Requst_Message[3]) + (Requst_Message[4] << 8 | Requst_Message[5]);
	switch (Requst_Message[1])
	{
	case 0x01:Create_0x01_Response_Message(Requst_Message, Response_Message, Address_range); break;
	case 0x03:Create_0x03_Response_Message(Requst_Message, Response_Message, Address_range); break;
	case 0x0F:Create_0x0F_Response_Message(Requst_Message, Response_Message, Address_range); break;
	case 0x10:Create_0x10_Response_Message(Requst_Message, Response_Message, Address_range); break;
		default: 
	}
	return true;
}



int test(void)
{
	string COMM;
	cin >> COMM;
	HANDLE Handle_Com = Init_COM((LPCTSTR)COMM.c_str(), 9600, 8, 0, 1);
	if (Handle_Com == INVALID_HANDLE_VALUE)
	{
		cout << "初始化串口失败" << endl;
		getchar();
		return 0;
	}

	char write_buf[MAX_NUMBER];
	memset(write_buf, 0, MAX_NUMBER);
	DWORD dwRead;
	while (true)
	{
		//RTU主站，生成并发送请求，计时，读取响应报文,先发送后接收
		//生成请求报文
		//发送请求报文

		PurgeComm(Handle_Com, PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR | PURGE_TXABORT);//清除缓存
		while (1)
		{
			if (true == SendData(Handle_Com, "ok", 2))
			{
				cout << "发送请求报文成功" << endl;
				break;
			}
		}
		BOOL bReadOK = ReadFile(Handle_Com, read_buf, 256, &dwRead, NULL);
		if (bReadOK && (dwRead > 0))
		{
			read_buf[dwRead] = '\0';
			printf("收到响应：%s \r\n", read_buf);
		}
		else
			cout << "loss" << endl;
	}
	CloseHandle(Handle_Com);
	getchar();
	return 0;
}
